#include "sdl.h"

SDL_Surface *font=NULL;

/* prints a message using the bitmap font */
void print(SDL_Surface *dst,int x,int y,unsigned char *text)
{
  SDL_Rect srcpos,dstpos;
  /* on the first call, load the font picture */
  if (!font) if ((font=IMG_Load("sprites/font.png"))==NULL)
    fprintf(stderr,"could not load font file\n");
  while (*text!='\0')
  {
    if (*text>=' ' && *text<' '+16*10)
    srcpos.x=(*text-' ')%16*10;
    srcpos.y=(*text-' ')/16*19;
    srcpos.w=10;
    srcpos.h=19;
    dstpos.x=x;
    dstpos.y=y;
    SDL_BlitSurface(font,&srcpos,dst,&dstpos);
    x+=10;
    text++;
  }
}

/* reads a string into the "text" variable */
void readstring(SDL_Surface *dst,int x,int y,unsigned char *text,int limit)
{
  SDL_Event event;
  int shift=0;

  SDL_EnableUNICODE(1);
  for (;;)
  {
    while (SDL_PollEvent(&event)) switch (event.type)
    {
      case SDL_KEYDOWN:
        switch (event.key.keysym.sym)
        {
          case SDLK_ESCAPE:
          case SDLK_RETURN:
            return;
          case SDLK_LSHIFT:
          case SDLK_RSHIFT:
            shift=1;
            break;
          case SDLK_BACKSPACE:
            if (strlen(text))
            {
              text[strlen(text)-1]='\0';
              print(dst,x+strlen(text)*10,y,"  ");
            }
            break;
          default:
            if ((event.key.keysym.unicode & 0xff80)==0 && strlen(text)<limit)
            {
              text[strlen(text)+1]='\0';
                    text[strlen(text)]=event.key.keysym.unicode & 0x7f;
            }
            break;
        }
        break;
    }
    print(dst,x,y,text);
    print(dst,x+strlen(text)*10,y,"_");
    SDL_Flip(dst);
    SDL_Delay(10);
  }
}

/*
 * Return the pixel value at (x, y)
 * NOTE: The surface must be locked before calling this!
 */
Uint32 getpixel(SDL_Surface *surface, int x, int y)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to retrieve */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        return *p;

    case 2:
        return *(Uint16 *)p;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN)
            return p[0] << 16 | p[1] << 8 | p[2];
        else
            return p[0] | p[1] << 8 | p[2] << 16;

    case 4:
        return *(Uint32 *)p;

    default:
        return 0;       /* shouldn't happen, but avoids warnings */
    }
}

/*
 * Set the pixel at (x, y) to the given value
 * NOTE: The surface must be locked before calling this!
 */
void putpixel(SDL_Surface *surface, int x, int y, Uint32 pixel)
{
    int bpp = surface->format->BytesPerPixel;
    /* Here p is the address to the pixel we want to set */
    Uint8 *p = (Uint8 *)surface->pixels + y * surface->pitch + x * bpp;

    switch(bpp) {
    case 1:
        *p = pixel;
        break;

    case 2:
        *(Uint16 *)p = pixel;
        break;

    case 3:
        if(SDL_BYTEORDER == SDL_BIG_ENDIAN) {
            p[0] = (pixel >> 16) & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = pixel & 0xff;
        } else {
            p[0] = pixel & 0xff;
            p[1] = (pixel >> 8) & 0xff;
            p[2] = (pixel >> 16) & 0xff;
        }
        break;

    case 4:
        *(Uint32 *)p = pixel;
        break;
    }
}
